// $Id: echoc.C,v 1.4 2008/11/20 11:14:20 dvermeir Exp $
#include <string>
#include <iostream>
#include "echoc.h"

EchoClient::EchoClient(Dv::shared_ptr<Dv::Net::Socket>& so): Dv::Thread::Thread(true), so_(so) {
  std::cerr << "create " << *this << std::endl;
}

EchoClient::~EchoClient() {
  std::cerr << "destroy " << *this << std::endl;
}

std::ostream&
operator<<(std::ostream& os, const EchoClient& echoc) {
  return os << "EchoClient for " << echoc.so().host() << ":" << echoc.so().port();
}

int
EchoClient::main() throw() { 
  std::string line; 
  while ( std::getline(so(), line) ) { 
    // Remove trailing '\r', if any. 
    if ( line.size() && (line[line.size()-1] == '\r') ) 
      line.erase(line.size()-1); 
    std::cout << *this << " > " << line << std::endl; 
    so() << line << std::endl; 
    if (line.size()==0) 
      break; 
  } 
  return 0;
}
