// $Id: echos.C,v 1.4 2008/11/20 11:14:20 dvermeir Exp $

#include <stdlib.h> // atoi
#include <iostream>
#include <dvnet/serversocket.h>

// A trivial echo server
int
main( int argc , char* argv[] ) {
  static const char* usage = "mtechos port";
  try {
    if (argc != 2)
      throw std::runtime_error(usage);

    // Upon failure, this constructor throws an exception.
    Dv::Net::ServerSocket  server(atoi(argv[1]));
  
    Dv::shared_ptr<Dv::Net::Socket>  client(server.accept());

    std::cout << "accept from " << client->host() << ":" << client->port() << std::endl;
    std::string line;
    while ( std::getline(*client, line) ) {
      // Remove trailing '\r', if any.
      if ( line.size() && (line[line.size()-1] == '\r') )
        line.erase(line.size()-1);
      std::cout << "> " << line << std::endl;
      *client << line << std::endl;
      if (line.size()==0)
        break;
    }
    std::cout << "client: " << client->strerror() << std::endl;
  }
  catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
    return 2;
  }
  return 0;
}
