// $Id: mtechos.C,v 1.4 2008/11/20 11:14:20 dvermeir Exp $

#include <stdlib.h> // atoi
#include <iostream>
#include <dvnet/serversocket.h>
#include "echoc.h"

//	A multi-threaded echo server
int
main( int argc , char* argv[] ) {
  static const char* usage = "mtechos port";
  try {
    if (argc != 2)
      throw std::runtime_error(usage);
  
    // Upon failure, this constructor throws an exception.
    Dv::Net::ServerSocket  server(atoi(argv[1]));
    while (true) {
      Dv::shared_ptr<Dv::Net::Socket>  so(server.accept());
      EchoClient::make(so)->start();
    }
  }
  catch (std::exception& e) {
    std::cerr << e.what() << std::endl;
    return 2;
  }
  return 0;
}
