// $Id: reader.h,v 1.4 2007/12/10 15:50:35 dvermeir Exp $
#include <iostream>
#include <stdexcept>
#include <dvthread/thread.h>

// A reader tries to retrieve items from a buffer.
class Reader: public Dv::Thread::Thread {
  public:
    // N is the number of items to retrieve.
    Reader(Buffer& buf, size_t n): Thread(), buffer_(buf), n_(n) {}
    
    virtual int main() throw () {
      try { 
        for (unsigned int i=0;(i<n_);++i)
          buffer_.get();
      }
      catch (std::exception& e) {
        std::cerr << e.what() << std::endl;
        return 1;
      }
      return 0;
    }
     // Wait for this thread to finish before detroying it.
    ~Reader() { join(); std::cerr << "~Reader()" << std::endl; } 
  private:
    Buffer&  buffer_; // From where items will be retrieved.
    size_t  n_; // Number of items to retrieve.
};
