// $Id: writer.h,v 1.4 2007/12/10 15:50:35 dvermeir Exp $
#include <iostream>
#include <stdexcept>
#include <dvthread/thread.h>

class Writer: public Dv::Thread::Thread {
  public:	
     // N is the number of items to put.
    Writer(Buffer& buf, unsigned int n): Thread(), buffer_(buf), n_(n) {}
    
    int main() throw () {
      try {
        for (unsigned int i=0; (i<n_);++i)
          buffer_.put(i);
      }
      catch (std::exception& e) {
        std::cerr << e.what() << std::endl;
        return 1;
      }
      return 0;
    }
     // Join this thread before destroying it.
    ~Writer() { join(); std::cerr << "~Writer()" << std::endl; } 
  private:
    Buffer& buffer_; // To which items will be written.
    unsigned int n_; // Number of items to write.
};
